/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/*  Fluent Bit
 *  ==========
 *  Copyright (C) 2015-2022 The Fluent Bit Authors
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

#ifndef FLB_VERSION_H
#define FLB_VERSION_H

#include <fluent-bit/flb_info.h>
#include <monkey/mk_core.h>

#include <stdio.h>
#include <stdlib.h>

/* Helpers to convert/format version string */
#define STR_HELPER(s)      #s
#define STR(s)             STR_HELPER(s)

/* Fluent Bit Version */
#define FLB_VERSION_MAJOR   22
#define FLB_VERSION_MINOR   4
#define FLB_VERSION_PATCH   5
#define FLB_VERSION         (FLB_VERSION_MAJOR * 10000 \
                             FLB_VERSION_MINOR * 100   \
                             FLB_VERSION_PATCH)
/* This is used in a few places like plugins and the metrics. */
#define FLB_VERSION_STR     "22.4.5"

#define FLB_GIT_HASH        ""

#define CFB_VERSION_STR       "22.4"
#define CFB_VERSION_PATCH_STR "5"

static inline void flb_version()
{
    printf("Calyptia Fluent Bit v%s, patch_level=%s\n",
           CFB_VERSION_STR, CFB_VERSION_PATCH_STR);
    exit(EXIT_SUCCESS);
}

static inline void flb_version_banner()
{
    fprintf(stderr,
            "%sCalyptia Fluent Bit v%s, patch_level=%s%s\n",
            ANSI_BOLD,
            CFB_VERSION_STR, CFB_VERSION_PATCH_STR,
            ANSI_RESET);
    fprintf(stderr, "* %sEnterprise Fluent Bit by Calyptia%s\n",
            ANSI_BOLD ANSI_YELLOW, ANSI_RESET);
    fprintf(stderr, "* https://calyptia.com\n");
    fprintf(stderr, "* https://fluentbit.io\n\n");
}

#endif
